xine-lib: xine-lib-1.2.13/src/demuxers/demux_elem.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions
demux_elem.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include "group_video.h"`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/compat.h>`
`#include <xine/demux.h>`

## Data Structures
struct | demux_mpeg_elem_t

## Macros
#define | LOG_MODULE "demux_elem"
#define | LOG_VERBOSE
#define | NUM_PREVIEW_BUFFERS 50
#define | SCRATCH_SIZE 256

## Functions
static int | demux_mpeg_elem_next (demux_mpeg_elem_t *this, int preview_mode)
static int | demux_mpeg_elem_send_chunk (demux_plugin_t *this_gen)
static int | demux_mpeg_elem_get_status (demux_plugin_t *this_gen)
static void | demux_mpeg_elem_send_headers (demux_plugin_t *this_gen)
static int | demux_mpeg_elem_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static int | demux_mpeg_elem_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_mpeg_elem_get_capabilities (demux_plugin_t *this_gen)
static int | demux_mpeg_elem_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
void * | demux_elem_init_class (xine_t *xine, const void *data)

## Macro Definition Documentation

## ◆ LOG_MODULE

#define LOG_MODULE "demux_elem"

## ◆ LOG_VERBOSE

#define LOG_VERBOSE

## ◆ NUM_PREVIEW_BUFFERS

#define NUM_PREVIEW_BUFFERS 50

Referenced by demux_mpeg_elem_send_headers().

## ◆ SCRATCH_SIZE

#define SCRATCH_SIZE 256

Referenced by open_plugin().

## Function Documentation

## ◆ demux_elem_init_class()

void * demux_elem_init_class | ( | xine_t * | xine,
|  | const void * | data )

References demux_plugin_s::dispose, N_, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ demux_mpeg_elem_get_capabilities()

static uint32_t demux_mpeg_elem_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_mpeg_elem_get_optional_data()

static int demux_mpeg_elem_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_mpeg_elem_get_status()

static int demux_mpeg_elem_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_mpeg_elem_get_stream_length()

static int demux_mpeg_elem_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_mpeg_elem_next()

static int demux_mpeg_elem_next | ( | demux_mpeg_elem_t * | this,
|  | int | preview_mode )
| static

References BUF_FLAG_PREVIEW, BUF_VIDEO_MPEG, buf_element_s::content, buf_element_s::decoder_flags, DEMUX_FINISHED, buf_element_s::extra_info, buf_element_s::free_buffer, input(), extra_info_s::input_normpos, lprintf, buf_element_s::max_size, buf_element_s::mem, buf_element_s::pts, buf_element_s::size, and buf_element_s::type.

Referenced by demux_mpeg_elem_send_chunk(), and demux_mpeg_elem_send_headers().

## ◆ demux_mpeg_elem_seek()

static int demux_mpeg_elem_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

References _x_demux_flush_engine(), DEMUX_FINISHED, DEMUX_OK, input(), INPUT_IS_SEEKABLE, and lprintf.

Referenced by open_plugin().

## ◆ demux_mpeg_elem_send_chunk()

static int demux_mpeg_elem_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_FINISHED, and demux_mpeg_elem_next().

Referenced by open_plugin().

## ◆ demux_mpeg_elem_send_headers()

static void demux_mpeg_elem_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), _x_stream_info_set(), demux_mpeg_elem_next(), DEMUX_OK, input(), INPUT_IS_SEEKABLE, NUM_PREVIEW_BUFFERS, XINE_STREAM_INFO_HAS_AUDIO, and XINE_STREAM_INFO_HAS_VIDEO.

Referenced by open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References _x_demux_read_header(), xine_stream_s::content_detection_method, default_demux_plugin_dispose, DEMUX_FINISHED, demux_mpeg_elem_get_capabilities(), demux_mpeg_elem_get_optional_data(), demux_mpeg_elem_get_status(), demux_mpeg_elem_get_stream_length(), demux_mpeg_elem_seek(), demux_mpeg_elem_send_chunk(), demux_mpeg_elem_send_headers(), input(), lprintf, METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, NULL, SCRATCH_SIZE, and input_plugin_s::seek.

Referenced by demux_elem_init_class().